/*
 * GQoob
 * (C) 2002 John Ellis
 *
 * Author: John Ellis
 *
 * This software is released under the GNU General Public License (GNU GPL).
 * Please read the included file COPYING for more information.
 * This software comes with no warranty of any kind, use at your own risk!
 */


#ifndef IO_XINE_H
#define IO_XINE_H

extern gchar *gqoob_xine_output_video;
extern gchar *gqoob_xine_output_audio;
extern gint gqoob_xine_debug;

/*
 * =========================== io_xine.c
 */

GList *gqoob_xine_get_video_list(void);
GList *gqoob_xine_get_audio_list(void);

gint gqoob_xine_override_plugin_config(const gchar *video, const gchar *audio);
void gqoob_xine_print_plugins(void);

void gqoob_xine_init(void);
void gqoob_xine_finish(void);
void gqoob_xine_ready(void);

void gqoob_xine_move(gint x, gint y, gint width, gint height, gint hidden);

gint gqoob_xine_speed_get(void);
void gqoob_xine_speed_set(gint speed);
gint gqoob_xine_speed_step(gint faster);
int gqoob_xine_speed_simple(gint speed);

void gqoob_xine_fullscreen_set(gint enable);

/*
 * =========================== io_xine_cfg.c
 */
void gqoob_xine_config_load(FILE *f, const gchar *option, const gchar *value, const gchar *value_all);
void gqoob_xine_config_save(FILE *f);
void gqoob_xine_config_apply(void);
void gqoob_xine_config_close(void);
GtkWidget *gqoob_xine_config_init(void);


#endif


